// test C++
//
// demonstrace prekryti zdedenych polozek
//

#include <iostream>             // cout
using namespace std;

/////////////////////////////////////////////////////////////////////////////
struct B {
    int i;
    B(): i(0) {}
    void f(int a) { cout << "B::f(" << a << ")\n"; }
};

struct D1 : B {
    int i;                      // hide B::i
    D1(): i(1) {}
    void f(int a, int b) {      // hide B::f
        cout << "D1::f(" << a << "," << b << ")\n"; 
    }
};

struct D2 : B {
    int i;                      // hide B::i
    D2(): i(2) {}
    void f(int a) {             // redefine B::f
        cout << "D2::f(" << a << ")\n"; 
    }
};

/////////////////////////////////////////////////////////////////////////////
void f(char) {
    cout << "void f(char)\n";
}

void g()
{
    extern void f(int);          // hide global f(char *)
    f('a');                      // call f(int)
}

void f(int) {
    cout << "void f(int)\n";
}

/////////////////////////////////////////////////////////////////////////////
int main()
{
    B b;
    D1 d1;
    D2 d2;

    b.f(0);
    // d1.f(1); // nelze - prekryto definici f(int,int)
    d1.B::f(1);
    d1.f(1,1);
    d2.f(2);

    cout << "b.i="     << b.i << endl;
    cout << "d1.i="    << d1.i << "  ";
    cout << "d1.B::i=" << d1.B::i << endl;
    cout << "d2.i="    << d2.i << "  ";
    cout << "d2.B::i=" << d2.B::i << endl;

    g();
}

